/* 
In this example code, it is shown how to make use of ScheduledExecutorService
to run delayed/periodic tasks.
*/

package cds;

import java.util.concurrent.*;

public class CDS_04_Scheduled {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //uncomment below what you want to test
        //sayDelayedHello(7);
        //sayPeriodicHello(0,4);
        //saySpacedHello(0,6);
    }
    
    private static void sayDelayedHello(int secs) {
        ScheduledExecutorService scheduler = Executors.newScheduledThreadPool(1);
        Runnable task = new Runnable(){
            public void run(){
                System.out.println("Hello World");
            }
        };
        ScheduledFuture sf = scheduler.schedule(task, secs, TimeUnit.SECONDS);
        try {
            sf.get();
        } catch (InterruptedException | ExecutionException ex) {}
        finally {
            scheduler.shutdown();
        }
    }
    
    
    
    private static void sayPeriodicHello(int secsDelay, int secsPeriod) {
        ScheduledExecutorService scheduler = Executors.newScheduledThreadPool(1);
        Runnable task = new Runnable(){
            public void run(){
                System.out.println("Hello World");
            }
        };
        ScheduledFuture sf = scheduler.scheduleAtFixedRate(task, secsDelay, secsPeriod, TimeUnit.SECONDS);
        try {
            sf.get(20, TimeUnit.SECONDS);
        } catch (TimeoutException | InterruptedException | ExecutionException ex) {}
        finally {
            scheduler.shutdown();
        }
    }
 
    
    
    private static void saySpacedHello(int secsDelay, int secsSpacing) {
        ScheduledExecutorService scheduler = Executors.newScheduledThreadPool(1);
        Runnable task = new Runnable(){
            public void run(){
                System.out.println("Hello World");
            }
        };
        ScheduledFuture sf = scheduler.scheduleWithFixedDelay(task, secsDelay, secsSpacing, TimeUnit.SECONDS);
        try {
            sf.get(15, TimeUnit.SECONDS);
        } catch (TimeoutException | InterruptedException | ExecutionException ex) {}
        finally {
            scheduler.shutdown();
        }
    }
}
